/*
	itoa.c
	funzione itoa(n, str, rad)
	converte l'intero n nella stringa str secondo la base
	determinata da rad, che pu essere un valore compreso
	tra 2 e 16, pone il risultato nella stringa str.
	Ritorna un puntatore alla stringa str.
*/
#define abs(x)	((x) < 0 ? -(x) : (x))

/*
	reverse: ribalta la stringa argomento
*/
void reverse(char *s)
{
	int i,j;
	char temp;

	i=0;
	while(s[i] != '\0')
		++i;
	--i;
	if (s[i]== '\n')
		--i;
	j = 0;
	while (j<i)
	{
		temp = s[j];
		s[j] = s[i];
		s[i] = temp;
		--i; ++j;
	}
}

char *itoa(int n, char *s, int w)
{
	int i, sign;

	sign = n;		/* registra il segno */
	i = 0;
	do			/* genera cifre in ordine inverso */
	{
		s[i++] = abs(n%10)+'0';
	} while ((n/=10) != 0);

	if (sign < 0)
		s[i++] = '-';
	while (i < w)
		s[i++] = ' ';
	s[i] = '\0';
	reverse(s);
	s[w]='\0';

	return(s);
}
